> For the complete documentation index, see [llms.txt](https://docs.fringe.fi/smart-contract-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fringe.fi/smart-contract-documentation/openzeppelin/contracts-upgradeable/governance/compatibility/igovernorcompatibilitybravoupgradeable.md).

# I Governor Compatibility Bravo Upgradeable

*Interface extension that adds missing functions to the {Governor} core to provide `GovernorBravo` compatibility. Available since v4.3.*

## Methods

### COUNTING\_MODE

```solidity
function COUNTING_MODE() external pure returns (string)
```

module:voting

*A description of the possible `support` values for {castVote} and the way these votes are counted, meant to be consumed by UIs to show correct vote options and interpret the results. The string is a URL-encoded sequence of key-value pairs that each describe one aspect, for example `support=bravo&amp;quorum=for,abstain`. There are 2 standard keys: `support` and `quorum`. - `support=bravo` refers to the vote options 0 = For, 1 = Against, 2 = Abstain, as in `GovernorBravo`. - `quorum=bravo` means that only For votes are counted towards quorum. - `quorum=for,abstain` means that both For and Abstain votes are counted towards quorum. NOTE: The string can be decoded by the standard <https://developer.mozilla.org/en-US/docs/Web/API/URLSearchParams\\[`URLSearchParams`>] JavaScript class.*

#### Returns

| Name | Type   | Description |
| ---- | ------ | ----------- |
| \_0  | string | undefined   |

### cancel

```solidity
function cancel(uint256 proposalId) external nonpayable
```

*Cancels a proposal only if sender is the proposer, or proposer delegates dropped below proposal threshold.*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

### castVote

```solidity
function castVote(uint256 proposalId, uint8 support) external nonpayable returns (uint256 balance)
```

*Cast a vote Emits a {VoteCast} event.*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |
| support    | uint8   | undefined   |

#### Returns

| Name    | Type    | Description |
| ------- | ------- | ----------- |
| balance | uint256 | undefined   |

### castVoteBySig

```solidity
function castVoteBySig(uint256 proposalId, uint8 support, uint8 v, bytes32 r, bytes32 s) external nonpayable returns (uint256 balance)
```

*Cast a vote using the user cryptographic signature. Emits a {VoteCast} event.*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |
| support    | uint8   | undefined   |
| v          | uint8   | undefined   |
| r          | bytes32 | undefined   |
| s          | bytes32 | undefined   |

#### Returns

| Name    | Type    | Description |
| ------- | ------- | ----------- |
| balance | uint256 | undefined   |

### castVoteWithReason

```solidity
function castVoteWithReason(uint256 proposalId, uint8 support, string reason) external nonpayable returns (uint256 balance)
```

*Cast a with a reason Emits a {VoteCast} event.*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |
| support    | uint8   | undefined   |
| reason     | string  | undefined   |

#### Returns

| Name    | Type    | Description |
| ------- | ------- | ----------- |
| balance | uint256 | undefined   |

### execute

```solidity
function execute(address[] targets, uint256[] values, bytes[] calldatas, bytes32 descriptionHash) external payable returns (uint256 proposalId)
```

*Execute a successful proposal. This requires the quorum to be reached, the vote to be successful, and the deadline to be reached. Emits a {ProposalExecuted} event. Note: some module can modify the requirements for execution, for example by adding an additional timelock.*

#### Parameters

| Name            | Type       | Description |
| --------------- | ---------- | ----------- |
| targets         | address\[] | undefined   |
| values          | uint256\[] | undefined   |
| calldatas       | bytes\[]   | undefined   |
| descriptionHash | bytes32    | undefined   |

#### Returns

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

### execute

```solidity
function execute(uint256 proposalId) external payable
```

*Part of the Governor Bravo's interface: "Executes a queued proposal if eta has passed".*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

### getActions

```solidity
function getActions(uint256 proposalId) external view returns (address[] targets, uint256[] values, string[] signatures, bytes[] calldatas)
```

*Part of the Governor Bravo's interface: "Gets actions of a proposal".*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

#### Returns

| Name       | Type       | Description |
| ---------- | ---------- | ----------- |
| targets    | address\[] | undefined   |
| values     | uint256\[] | undefined   |
| signatures | string\[]  | undefined   |
| calldatas  | bytes\[]   | undefined   |

### getReceipt

```solidity
function getReceipt(uint256 proposalId, address voter) external view returns (struct IGovernorCompatibilityBravoUpgradeable.Receipt)
```

*Part of the Governor Bravo's interface: "Gets the receipt for a voter on a given proposal".*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |
| voter      | address | undefined   |

#### Returns

| Name | Type                                           | Description |
| ---- | ---------------------------------------------- | ----------- |
| \_0  | IGovernorCompatibilityBravoUpgradeable.Receipt | undefined   |

### getVotes

```solidity
function getVotes(address account, uint256 blockNumber) external view returns (uint256)
```

module:reputation

*Voting power of an `account` at a specific `blockNumber`. Note: this can be implemented in a number of ways, for example by reading the delegated balance from one (or multiple), {ERC20Votes} tokens.*

#### Parameters

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| account     | address | undefined   |
| blockNumber | uint256 | undefined   |

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### hasVoted

```solidity
function hasVoted(uint256 proposalId, address account) external view returns (bool)
```

module:voting

*Returns weither `account` has cast a vote on `proposalId`.*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |
| account    | address | undefined   |

#### Returns

| Name | Type | Description |
| ---- | ---- | ----------- |
| \_0  | bool | undefined   |

### hashProposal

```solidity
function hashProposal(address[] targets, uint256[] values, bytes[] calldatas, bytes32 descriptionHash) external pure returns (uint256)
```

module:core

*Hashing function used to (re)build the proposal id from the proposal details..*

#### Parameters

| Name            | Type       | Description |
| --------------- | ---------- | ----------- |
| targets         | address\[] | undefined   |
| values          | uint256\[] | undefined   |
| calldatas       | bytes\[]   | undefined   |
| descriptionHash | bytes32    | undefined   |

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### name

```solidity
function name() external view returns (string)
```

module:core

*Name of the governor instance (used in building the ERC712 domain separator).*

#### Returns

| Name | Type   | Description |
| ---- | ------ | ----------- |
| \_0  | string | undefined   |

### proposalDeadline

```solidity
function proposalDeadline(uint256 proposalId) external view returns (uint256)
```

module:core

*timestamp at which votes close.*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### proposalSnapshot

```solidity
function proposalSnapshot(uint256 proposalId) external view returns (uint256)
```

module:core

*block number used to retrieve user's votes and quorum.*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### proposalThreshold

```solidity
function proposalThreshold() external view returns (uint256)
```

*Part of the Governor Bravo's interface: "The number of votes required in order for a voter to become a proposer".*

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### proposals

```solidity
function proposals(uint256) external view returns (uint256 id, address proposer, uint256 eta, uint256 startBlock, uint256 endBlock, uint256 forVotes, uint256 againstVotes, uint256 abstainVotes, bool canceled, bool executed)
```

*Part of the Governor Bravo's interface: "The official record of all proposals ever proposed".*

#### Parameters

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

#### Returns

| Name         | Type    | Description |
| ------------ | ------- | ----------- |
| id           | uint256 | undefined   |
| proposer     | address | undefined   |
| eta          | uint256 | undefined   |
| startBlock   | uint256 | undefined   |
| endBlock     | uint256 | undefined   |
| forVotes     | uint256 | undefined   |
| againstVotes | uint256 | undefined   |
| abstainVotes | uint256 | undefined   |
| canceled     | bool    | undefined   |
| executed     | bool    | undefined   |

### propose

```solidity
function propose(address[] targets, uint256[] values, bytes[] calldatas, string description) external nonpayable returns (uint256 proposalId)
```

*Create a new proposal. Vote start {IGovernor-votingDelay} blocks after the proposal is created and ends {IGovernor-votingPeriod} blocks after the voting starts. Emits a {ProposalCreated} event.*

#### Parameters

| Name        | Type       | Description |
| ----------- | ---------- | ----------- |
| targets     | address\[] | undefined   |
| values      | uint256\[] | undefined   |
| calldatas   | bytes\[]   | undefined   |
| description | string     | undefined   |

#### Returns

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

### propose

```solidity
function propose(address[] targets, uint256[] values, string[] signatures, bytes[] calldatas, string description) external nonpayable returns (uint256)
```

*Part of the Governor Bravo's interface: "Function used to propose a new proposal".*

#### Parameters

| Name        | Type       | Description |
| ----------- | ---------- | ----------- |
| targets     | address\[] | undefined   |
| values      | uint256\[] | undefined   |
| signatures  | string\[]  | undefined   |
| calldatas   | bytes\[]   | undefined   |
| description | string     | undefined   |

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### queue

```solidity
function queue(uint256 proposalId) external nonpayable
```

*Part of the Governor Bravo's interface: "Queues a proposal of state succeeded".*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

### quorum

```solidity
function quorum(uint256 blockNumber) external view returns (uint256)
```

module:user-config

*Minimum number of cast voted required for a proposal to be successful. Note: The `blockNumber` parameter corresponds to the snaphot used for counting vote. This allows to scale the quroum depending on values such as the totalSupply of a token at this block (see {ERC20Votes}).*

#### Parameters

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| blockNumber | uint256 | undefined   |

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### quorumVotes

```solidity
function quorumVotes() external view returns (uint256)
```

*Part of the Governor Bravo's interface.*

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### state

```solidity
function state(uint256 proposalId) external view returns (enum IGovernorUpgradeable.ProposalState)
```

module:core

*Current state of a proposal, following Compound's convention*

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

#### Returns

| Name | Type                                    | Description |
| ---- | --------------------------------------- | ----------- |
| \_0  | enum IGovernorUpgradeable.ProposalState | undefined   |

### supportsInterface

```solidity
function supportsInterface(bytes4 interfaceId) external view returns (bool)
```

*Returns true if this contract implements the interface defined by `interfaceId`. See the corresponding <https://eips.ethereum.org/EIPS/eip-165#how-interfaces-are-identified\\[EIP> section] to learn more about how these ids are created. This function call must use less than 30 000 gas.*

#### Parameters

| Name        | Type   | Description |
| ----------- | ------ | ----------- |
| interfaceId | bytes4 | undefined   |

#### Returns

| Name | Type | Description |
| ---- | ---- | ----------- |
| \_0  | bool | undefined   |

### version

```solidity
function version() external view returns (string)
```

module:core

*Version of the governor instance (used in building the ERC712 domain separator). Default: "1"*

#### Returns

| Name | Type   | Description |
| ---- | ------ | ----------- |
| \_0  | string | undefined   |

### votingDelay

```solidity
function votingDelay() external view returns (uint256)
```

module:user-config

*delay, in number of block, between the proposal is created and the vote starts. This can be increassed to leave time for users to buy voting power, of delegate it, before the voting of a proposal starts.*

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

### votingPeriod

```solidity
function votingPeriod() external view returns (uint256)
```

module:user-config

*delay, in number of blocks, between the vote start and vote ends. Note: the {votingDelay} can delay the start of the vote. This must be considered when setting the voting duration compared to the voting delay.*

#### Returns

| Name | Type    | Description |
| ---- | ------- | ----------- |
| \_0  | uint256 | undefined   |

## Events

### ProposalCanceled

```solidity
event ProposalCanceled(uint256 proposalId)
```

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

### ProposalCreated

```solidity
event ProposalCreated(uint256 proposalId, address proposer, address[] targets, uint256[] values, string[] signatures, bytes[] calldatas, uint256 startBlock, uint256 endBlock, string description)
```

#### Parameters

| Name        | Type       | Description |
| ----------- | ---------- | ----------- |
| proposalId  | uint256    | undefined   |
| proposer    | address    | undefined   |
| targets     | address\[] | undefined   |
| values      | uint256\[] | undefined   |
| signatures  | string\[]  | undefined   |
| calldatas   | bytes\[]   | undefined   |
| startBlock  | uint256    | undefined   |
| endBlock    | uint256    | undefined   |
| description | string     | undefined   |

### ProposalExecuted

```solidity
event ProposalExecuted(uint256 proposalId)
```

#### Parameters

| Name       | Type    | Description |
| ---------- | ------- | ----------- |
| proposalId | uint256 | undefined   |

### VoteCast

```solidity
event VoteCast(address indexed voter, uint256 proposalId, uint8 support, uint256 weight, string reason)
```

#### Parameters

| Name            | Type    | Description |
| --------------- | ------- | ----------- |
| voter `indexed` | address | undefined   |
| proposalId      | uint256 | undefined   |
| support         | uint8   | undefined   |
| weight          | uint256 | undefined   |
| reason          | string  | undefined   |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fringe.fi/smart-contract-documentation/openzeppelin/contracts-upgradeable/governance/compatibility/igovernorcompatibilitybravoupgradeable.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
